SQLMODE INTERNAL
/ *
CREATE TABLE "DBO"."ORTT"
(
	"RateDate"               Timestamp    NOT NULL,
	"Currency"               Varchar (3) UNICODE    NOT NULL,
	"Rate"               Float (16),
	"DataSource"               Char (1) UNICODE,
	"UserSign"               Smallint
)
/ *
CREATE TABLE "DBO"."OSQR"
(
	"IntrnalKey"               Integer    NOT NULL,
	"QGroups"               Smallint,
	"QName"               Varchar (100) UNICODE    NOT NULL,
	"QString"               Long UNICODE,
	"QType"               Char (1) UNICODE,
	"ColumnSize"               Varchar (100) UNICODE
)
/ *
CREATE TABLE "DBO"."SCAB"
(
	"Version"               Integer    NOT NULL,
	"Flags"               Varchar (50) UNICODE,
	"ApplCab"               Long UNICODE,
	"DbCab"               Long UNICODE
)
/ *
CREATE TABLE "DBO"."SCSP"
(
	"SpName"               Varchar (50) UNICODE    NOT NULL,
	"SpString"               Long UNICODE,
	"doBefore"               Char (1) UNICODE
)
/ *
CREATE TABLE "DBO"."SDRC"
(
	"ObjectId"               Varchar (4) UNICODE    NOT NULL,
	"DescStr"               Varchar (30) UNICODE,
	"VisOrder"               Smallint,
	"PartOf"               Char (1) UNICODE
)
/ *
CREATE TABLE "DBO"."SDRF"
(
	"ObjectId"               Varchar (4) UNICODE    NOT NULL,
	"DescStr"               Varchar (30) UNICODE,
	"FatherId"               Varchar (4) UNICODE,
	"VisLevel"               Smallint,
	"VisOrder"               Smallint
)
/ *
CREATE TABLE "DBO"."SDRO"
(
	"ObjectId"               Varchar (4) UNICODE    NOT NULL,
	"FieldId"               Smallint    NOT NULL,
	"DescStr"               Varchar (30) UNICODE,
	"VisOrder"               Smallint
)
/ *
CREATE TABLE "DBO"."SDRQ"
(
	"ObjTo"               Varchar (4) UNICODE    NOT NULL,
	"ObjFrom"               Varchar (4) UNICODE    NOT NULL,
	"JoinStr"               Varchar (254) UNICODE,
	"FilterStr"               Varchar (128) UNICODE
)
/ *
CREATE TABLE "DBO"."SDRR"
(
	"ObjId"               Varchar (4) UNICODE    NOT NULL,
	"ReportStr"               Long UNICODE
)
/ *
CREATE TABLE "DBO"."SHQR"
(
	"Version"               Integer    NOT NULL,
	"TableId"               Varchar (4) UNICODE    NOT NULL,
	"Instance"               Smallint    NOT NULL,
	"DoBefore"               Char (1) UNICODE    NOT NULL,
	"QurString"               Long UNICODE
)
/ *
CREATE TABLE "DBO"."SINF"
(
	"Version"               Integer    NOT NULL,
	"Flags"               Varchar (50) UNICODE,
	"UpgCab"               Long UNICODE
)
/ *
CREATE TABLE "DBO"."SLSC"
(
	"LocCode"               Varchar (3) UNICODE    NOT NULL,
	"Code"               Varchar (20) UNICODE    NOT NULL,
	"Name"               Varchar (100) UNICODE,
	"Type"               Char (1) UNICODE,
	"DataCab"               Long UNICODE,
	"System"               Char (1) UNICODE
)
/ *
CREATE TABLE "DBO"."SLSD"
(
	"Code"               Varchar (3) UNICODE    NOT NULL,
	"Name"               Varchar (100) UNICODE,
	"DefLang"               Integer
)
/ *
CREATE TABLE "DBO"."SRGC"
(
	"dbName"               Varchar (100) UNICODE    NOT NULL,
	"cmpName"               Varchar (100) UNICODE,
	"versStr"               Varchar (10) UNICODE,
	"dbUser"               Varchar (50) UNICODE    NOT NULL
)
/ *
CREATE TABLE "DBO"."sysSAPBODatabases"
(
	"DbName"               Varchar (8) UNICODE,
	"compName"               Varchar (100) UNICODE,
	"cmpVers"               Integer,
	"cmpUser"               Varchar (50) UNICODE
)
/ *
CREATE DBPROC TMSP_GETCOMPLIST  RETURNS CURSOR    AS VAR COMPS INT; BEGIN   SET COMPS = 0;   SELECT COMPS = COUNT(1) FROM DBO.SRGC;   IF (COMPS <= 0) THEN   BEGIN  CALL TMSP_REFRESHCOMPLIST;   END;   DECLARE :$CURSOR CURSOR FOR SELECT * FROM DBO."SRGC"   WHERE "dbUser" =   CHR(USER,50); END; 
/ *
CREATE DBPROC TMSP_GETCOMPLIST  RETURNS CURSOR    AS VAR COMPS INT; BEGIN   SET COMPS = 0;   SELECT COMPS = COUNT(1) FROM DBO.SRGC;   IF (COMPS <= 0) THEN   BEGIN  CALL TMSP_REFRESHCOMPLIST;   END;   DECLARE :$CURSOR CURSOR FOR SELECT * FROM DBO."SRGC"   WHERE "dbUser" =   CHR(USER,50); END; 
/ *
CREATE DBPROC TMSP_REFRESHCOMPLIST     AS  VAR DB CHAR(8);  DBUSER  VARCHAR (50); CMPVERS INT; CMPN VARCHAR(100); BEGIN     /*SET NOCOUNT ON*/     TRY     CREATE TABLE TEMP.#VALIDATEDB (           "DbName" VARCHAR(100),            "compName" VARCHAR(100) NULL,            "cmpVers" INT    NULL,            "cmpUser" VARCHAR(50));     SELECT "DbName" FROM DBO."sysSAPBODatabases";     CATCH     IF ($RC <> 0 ) THEN STOP ($RC, $ERRMSG);     FETCH INTO :DB;     WHILE $RC = 0 DO BEGIN        SET DB = LTRIM (RTRIM(DB));        SELECT "cmpVers", "compName" INTO :CMPVERS, :CMPN               FROM DBO."sysSAPBODatabases"               WHERE "DbName" = :DB;              SET CMPN = LTRIM (RTRIM(CMPN));              INSERT INTO TEMP.#VALIDATEDB ("DbName", "compName", "cmpVers", "cmpUser")               VALUES(:DB, :CMPN, :CMPVERS, USER);        FETCH INTO :DB;     END;     SET DBUSER =  CHR(USER,50);     DELETE FROM DBO."SRGC" WHERE "dbUser" = :DBUSER;     INSERT INTO DBO."SRGC" SELECT * FROM TEMP.#VALIDATEDB;     DROP TABLE TEMP.#VALIDATEDB; END; 
/ *
CREATE DBPROC TMSP_REFRESHCOMPLIST     AS  VAR DB CHAR(8);  DBUSER  VARCHAR (50); CMPVERS INT; CMPN VARCHAR(100); BEGIN     /*SET NOCOUNT ON*/     TRY     CREATE TABLE TEMP.#VALIDATEDB (           "DbName" VARCHAR(100),            "compName" VARCHAR(100) NULL,            "cmpVers" INT    NULL,            "cmpUser" VARCHAR(50));     SELECT "DbName" FROM DBO."sysSAPBODatabases";     CATCH     IF ($RC <> 0 ) THEN STOP ($RC, $ERRMSG);     FETCH INTO :DB;     WHILE $RC = 0 DO BEGIN        SET DB = LTRIM (RTRIM(DB));        SELECT "cmpVers", "compName" INTO :CMPVERS, :CMPN               FROM DBO."sysSAPBODatabases"               WHERE "DbName" = :DB;              SET CMPN = LTRIM (RTRIM(CMPN));              INSERT INTO TEMP.#VALIDATEDB ("DbName", "compName", "cmpVers", "cmpUser")               VALUES(:DB, :CMPN, :CMPVERS, USER);        FETCH INTO :DB;     END;     SET DBUSER =  CHR(USER,50);     DELETE FROM DBO."SRGC" WHERE "dbUser" = :DBUSER;     INSERT INTO DBO."SRGC" SELECT * FROM TEMP.#VALIDATEDB;     DROP TABLE TEMP.#VALIDATEDB; END; 
/ *

